--- ser-0.8.14/modules/nathelper/nathelper.c	2004-07-15 23:18:34.000000000 +0200
+++ ser-0.8.14_mod/modules/nathelper/nathelper.c	2004-11-08 16:17:09.000000000 +0100
@@ -178,8 +178,12 @@
 static int fix_nated_sdp_f(struct sip_msg *, char *, char *);
 static int extract_mediaip(str *, str *, int *);
 static int extract_mediaport(str *, str *);
+static int extract_mediaport2(str *, str *,str *);
+
 static int alter_mediaip(struct sip_msg *, str *, str *, int, str *, int, int);
 static int alter_mediaport(struct sip_msg *, str *, str *, str *, int);
+static int alter_mediaport2(struct sip_msg *, str *, str *, str *, str *, str * , int);
+
 static char *gencookie();
 static int rtpp_test(int, int);
 static char *send_rtpp_command(struct iovec *, int);
@@ -261,6 +265,7 @@
 static int
 mod_init(void)
 {
+
 	int i;
 	char *cp;
 	bind_usrloc_t bind_usrloc;
@@ -708,6 +713,11 @@
 #define	AOLDMEDPRT	"a=oldmediaport:"
 #define	AOLDMEDPRT_LEN	(sizeof(AOLDMEDPRT) - 1)
 
+
+#define AOLDMEDPRT2     "a=oldmediaport2:"
+#define AOLDMEDPRT2_LEN  (sizeof(AOLDMEDPRT2) - 1)
+
+
 #define	ANORTPPROXY	"a=nortpproxy:yes\r\n"
 #define	ANORTPPROXY_LEN	(sizeof(ANORTPPROXY) - 1)
 
@@ -874,6 +884,78 @@
 	return 1;
 }
 
+
+static int
+extract_mediaport2(str *body, str *mediaport, str *mediaport2)
+{
+        char *cp, *cp2, *cp1;
+        int len;
+
+        cp1 = NULL;
+        for (cp = body->s; (len = body->s + body->len - cp) > 0;) {
+                cp1 = ser_memmem(cp, "m=", len, 2);
+                if (cp1 == NULL || cp1[-1] == '\n' || cp1[-1] == '\r')
+                        break;
+                cp = cp1 + 2;
+        }
+        if (cp1 == NULL) {
+                LOG(L_ERR, "ERROR: extract_mediaport21: no `m=' in SDP\n");
+                return -1;
+        }
+	
+        mediaport->s = cp1 + 2;
+
+	 cp2 = NULL;
+        for (cp2= mediaport->s; (len = body->s + body->len - cp2) > 0;) {
+                cp1 = ser_memmem(cp2, "m=", len, 2);
+                if (cp1 == NULL || cp1[-1] == '\n' || cp1[-1] == '\r')
+                        break;
+                cp2 = cp1 + 2;
+        }
+        if (cp1 == NULL) {
+                LOG(L_ERR, "ERROR: extract_mediaport22: no `m=' in SDP\n");
+                return -1;
+        }
+	mediaport2->s = cp1 + 2;
+
+        mediaport->len = eat_line(mediaport->s, body->s + body->len -
+          mediaport->s) - mediaport->s;
+        trim_len(mediaport->len, mediaport->s, *mediaport);
+
+	mediaport2->len = eat_line(mediaport2->s, body->s + body->len -
+          mediaport2->s) - mediaport2->s;
+        trim_len(mediaport2->len, mediaport2->s, *mediaport2);
+
+        if (mediaport->len < 7 || ! (memcmp(mediaport->s, "audio", 5) != 0 || memcmp(mediaport->s, "video", 5) != 0) ||
+          !isspace((int)mediaport->s[5])) {
+                LOG(L_ERR, "ERROR: extract_mediaport222: can't parse `m=' in SDP\n");
+                return -1;
+        }
+
+	 if (mediaport2->len < 7 || ! (memcmp(mediaport2->s, "audio", 5) != 0 || memcmp(mediaport2->s, "video", 5) != 0) ||
+          !isspace((int)mediaport2->s[5])) {
+                LOG(L_ERR, "ERROR: extract_mediaport222: can't parse `m=' in SDP\n");
+                return -1;
+        }
+
+
+        cp = eat_space_end(mediaport->s + 5, mediaport->s + mediaport->len);
+
+        mediaport->len = eat_token_end(cp, mediaport->s + mediaport->len) - cp;
+        mediaport->s = cp;
+      
+	cp = eat_space_end(mediaport2->s + 5, mediaport2->s + mediaport2->len);
+
+        mediaport2->len = eat_token_end(cp, mediaport2->s + mediaport2->len) - cp;
+        mediaport2->s = cp;
+
+	return 1; 
+	
+
+}
+
+
+
 static int
 alter_mediaip(struct sip_msg *msg, str *body, str *oldip, int oldpf,
   str *newip, int newpf, int preserve)
@@ -962,18 +1044,24 @@
 }
 
 static int
-alter_mediaport(struct sip_msg *msg, str *body, str *oldport, str *newport,
+alter_mediaport2(struct sip_msg *msg, str *body, str *oldport, str *newport, str *oldport2, str *newport2,
   int preserve)
 {
-	char *buf;
+	char *buf, *buf2;
 	int offset;
-	struct lump* anchor;
+	struct lump* anchor,* anchor2;
 
 	/* check that updating mediaport is really necessary */
 	if (newport->len == oldport->len &&
 	    memcmp(newport->s, oldport->s, newport->len) == 0)
 		return 0;
 
+
+	  if (newport2->len == oldport2->len &&
+            memcmp(newport2->s, oldport2->s, newport2->len) == 0)
+                return 0;
+
+
 	if (preserve != 0) {
 		anchor = anchor_lump(msg, body->s + body->len - msg->buf, 0, 0);
 		if (anchor == NULL) {
@@ -994,6 +1082,28 @@
 			pkg_free(buf);
 			return -1;
 		}
+	
+
+		anchor2 = anchor_lump(msg, body->s + body->len - msg->buf, 0, 0);
+                if (anchor2 == NULL) {
+                        LOG(L_ERR, "ERROR: alter_mediaport: anchor_lump failed\n");
+                        return -1;
+                }
+                buf2 = pkg_malloc(AOLDMEDPRT2_LEN + oldport2->len + CRLF_LEN);
+                if (buf2 == NULL) {
+                        LOG(L_ERR, "ERROR: alter_mediaport: out of memory\n");
+                        return -1;
+                }
+                memcpy(buf2, AOLDMEDPRT2, AOLDMEDPRT2_LEN);
+                memcpy(buf2 + AOLDMEDPRT2_LEN, oldport2->s, oldport2->len);
+                memcpy(buf2 + AOLDMEDPRT2_LEN + oldport2->len, CRLF, CRLF_LEN);
+                if (insert_new_lump_after(anchor2, buf2,
+                    AOLDMEDPRT2_LEN + oldport2->len + CRLF_LEN, 0) == NULL) {
+                        LOG(L_ERR, "ERROR: alter_mediaport: insert_new_lump_after failed\n");
+                        pkg_free(buf2);
+                        return -1;
+                }
+
 	}
 
 	buf = pkg_malloc(newport->len);
@@ -1014,9 +1124,89 @@
 		pkg_free(buf);
 		return -1;
 	}
+
+
+
+	buf2 = pkg_malloc(newport2->len);
+        if (buf2 == NULL) {
+                LOG(L_ERR, "ERROR: alter_mediaport: out of memory\n");
+                return -1;
+        }
+        offset = oldport2->s - msg->buf;
+        anchor2 = del_lump(msg, offset, oldport2->len, 0);
+        if (anchor2 == NULL) {
+                LOG(L_ERR, "ERROR: alter_mediaport: del_lump failed\n");
+                pkg_free(buf2);
+                return -1;
+        }
+        memcpy(buf2, newport2->s, newport2->len);
+        if (insert_new_lump_after(anchor2, buf2, newport2->len, 0) == 0) {
+                LOG(L_ERR, "ERROR: alter_mediaport: insert_new_lump_after failed\n");
+                pkg_free(buf2);
+                return -1;
+        }
+	
 	return 0;
 }
 
+static int
+alter_mediaport(struct sip_msg *msg, str *body, str *oldport, str *newport,
+  int preserve)
+{
+        char *buf;
+        int offset;
+        struct lump* anchor;
+
+        /* check that updating mediaport is really necessary */
+        if (newport->len == oldport->len &&
+            memcmp(newport->s, oldport->s, newport->len) == 0)
+                return 0;
+
+        if (preserve != 0) {
+                anchor = anchor_lump(msg, body->s + body->len - msg->buf, 0, 0);
+                if (anchor == NULL) {
+                        LOG(L_ERR, "ERROR: alter_mediaport: anchor_lump failed\n");
+                        return -1;
+                }
+                buf = pkg_malloc(AOLDMEDPRT_LEN + oldport->len + CRLF_LEN);
+                if (buf == NULL) {
+                        LOG(L_ERR, "ERROR: alter_mediaport: out of memory\n");
+                        return -1;
+                }
+                memcpy(buf, AOLDMEDPRT, AOLDMEDPRT_LEN);
+                memcpy(buf + AOLDMEDPRT_LEN, oldport->s, oldport->len);
+                memcpy(buf + AOLDMEDPRT_LEN + oldport->len, CRLF, CRLF_LEN);
+                if (insert_new_lump_after(anchor, buf,
+                    AOLDMEDPRT_LEN + oldport->len + CRLF_LEN, 0) == NULL) {
+                        LOG(L_ERR, "ERROR: alter_mediaport: insert_new_lump_after failed\n");
+                        pkg_free(buf);
+                        return -1;
+                }
+        }
+
+        buf = pkg_malloc(newport->len);
+        if (buf == NULL) {
+                LOG(L_ERR, "ERROR: alter_mediaport: out of memory\n");
+                return -1;
+        }
+        offset = oldport->s - msg->buf;
+        anchor = del_lump(msg, offset, oldport->len, 0);
+        if (anchor == NULL) {
+                LOG(L_ERR, "ERROR: alter_mediaport: del_lump failed\n");
+                pkg_free(buf);
+                return -1;
+        }
+        memcpy(buf, newport->s, newport->len);
+        if (insert_new_lump_after(anchor, buf, newport->len, 0) == 0) {
+                LOG(L_ERR, "ERROR: alter_mediaport: insert_new_lump_after failed\n");
+                pkg_free(buf);
+                return -1;
+        }
+        return 0;
+}
+
+
+
 static char *
 gencookie()
 {
@@ -1204,11 +1394,15 @@
 static int
 force_rtp_proxy2_f(struct sip_msg* msg, char* str1, char* str2)
 {
-	str body, body1, oldport, oldip, oldip1, newport, newip;
+	str body, body1, oldport, oldip, oldip1, newport, newip, oldport2, newport2;
+	
 	str callid, from_tag, to_tag, tmp;
-	int create, port, len, asymmetric, flookup, argc, proxied, real;
+	int create, port, port2 , len, asymmetric, flookup, argc, proxied, real;
 	int oidx, pf, pf1, force;
+
+	int video=1;
 	char opts[16];
+	char opts2[16];
 	char *cp, *cp1;
 	char  *cpend, *next;
 	char **ap, *argv[10];
@@ -1340,25 +1534,49 @@
 		    "families in SDP\n");
 		return -1;
 	}
-	if (extract_mediaport(&body, &oldport) == -1) {
-		LOG(L_ERR, "ERROR: force_rtp_proxy2: can't extract media port "
-		    "from the message\n");
-		return -1;
+	
+	if (extract_mediaport2(&body, &oldport,&oldport2) == -1) {
+
+		if (extract_mediaport(&body, &oldport) == -1) {
+			LOG(L_ERR, "ERROR: force_rtp_proxy2: can't extract media port "
+			    "from the message\n");
+			return -1;
+		}else 
+		{
+			video=-1;
+			LOG(L_ERR, "no video \n");
+		}
+
 	}
 	if (pf == AF_INET6) {
 		opts[oidx] = '6';
 		oidx++;
 	}
+
+
 	opts[0] = (create == 0) ? 'L' : 'U';
 	v[1].iov_len = oidx;
-	STR2IOVEC(callid, v[3]);
+
+
+	str callid1;
+	char callid1s[callid.len+1];
+	memcpy(callid1s,"a",1);
+	memcpy(callid1s+1,callid.s,callid.len);
+
+	callid1.s = callid1s;
+	callid1.len = sizeof(callid1.s);		
+
+	STR2IOVEC(callid1, v[3]);
 	STR2IOVEC(newip, v[5]);
 	STR2IOVEC(oldport, v[7]);
 	STR2IOVEC(from_tag, v[9]);
 	STR2IOVEC(to_tag, v[11]);
 	cp = send_rtpp_command(v, (to_tag.len > 0) ? 12 : 10);
 	if (cp == NULL)
+		{
+		 LOG(L_ERR, "error send rtp command \n");	
 		return -1;
+		}
 	argc = 0;
 	memset(argv, 0, sizeof(argv));
 	cpend=cp+strlen(cp);
@@ -1378,6 +1596,47 @@
 	if (port <= 0 || port > 65535)
 		return -1;
 
+
+	if (video==1)
+	{
+		 str callid2;
+        	char callid2s[callid.len+1];
+	
+		memcpy(callid2s,"v",1);
+        	memcpy(callid2s+1,callid.s,callid.len);
+        	callid2.s = callid2s;
+        	callid2.len = sizeof(callid2.s);
+
+
+		STR2IOVEC(callid2, v[3]);
+        	STR2IOVEC(oldport2, v[7]);
+        	cp = send_rtpp_command(v, (to_tag.len > 0) ? 12 : 10);
+        	if (cp == NULL)
+		{
+
+			LOG(L_ERR, "error 2 end rtp command \n");
+                	return -1;
+		}
+        	argc = 0;
+        	memset(argv, 0, sizeof(argv));
+        	cpend=cp+strlen(cp);
+        	next=eat_token_end(cp, cpend);
+        	for (ap = argv; cp<cpend; cp=next+1, next=eat_token_end(cp, cpend)){
+                	*next=0;
+                	if (*cp != '\0') {
+                        	*ap=cp;
+                        	argc++;
+                        	if ((char*)++ap >= ((char*)argv+sizeof(argv)))
+                                	break;
+                	}
+        	}
+	        if (argc < 1)
+        	        return -1;
+        	port2 = atoi(argv[0]);
+        	if (port2 <= 0 || port > 65535)
+                	return -1;
+	}
+
 	pf1 = (argc >= 3 && argv[2][0] == '6') ? AF_INET6 : AF_INET;
 
 	if (isnulladdr(&oldip, pf)) {
@@ -1392,15 +1651,34 @@
 		newip.s = (argc < 2) ? str2 : argv[1];
 		newip.len = strlen(newip.s);
 	}
-	newport.s=int2str(port, &newport.len); /* beware static buffer */
 	
+	char cport[5];
+	int lencport;
+	memcpy(cport,int2str(port, &lencport),lencport); /* beware static buffer */
+	newport.s = cport;
+	newport.len = lencport;
+	
+	if (video==1)
+		newport2.s=int2str(port2, &newport2.len); /* beware static buffer */
+
 	if (alter_mediaip(msg, &body, &oldip, pf, &newip, pf1, 0) == -1)
 		return -1;
+	
 	if (oldip1.len > 0 &&
 	    alter_mediaip(msg, &body1, &oldip1, pf, &newip, pf1, 0) == -1)
 		return -1;
-	if (alter_mediaport(msg, &body, &oldport, &newport, 0) == -1)
-		return -1;
+
+	if (video==1)
+	
+	{
+		 if (alter_mediaport2(msg, &body, &oldport, &newport, &oldport2, &newport2, 0) == -1)
+                        return -1; 
+	}
+	else
+	{
+		if (alter_mediaport(msg, &body, &oldport, &newport, 0) == -1)
+			return -1;
+	}
 
 	if (proxied == 0) {
 		cp = pkg_malloc(ANORTPPROXY_LEN * sizeof(char));
